<?php
require_once(DOL_DOCUMENT_ROOT."/MCCImport/Parser.class.php");
require_once(DOL_DOCUMENT_ROOT."/MCCImport/OperationProcessor.class.php");

class FrancesParser extends Parser{

    var $line;
    var $data = array();
    var $dateop;
    var $dateop2;
    var $operation;
    var $num_chq;
    var $label;
    var $cat1;
    var $amount;
    var $processLine = true;
    
    public function __construct($line,$delimiter,$op,$defaultOperation) {
        if (preg_match("/[0-9]/",$line{0}) == 0){
            $this->processLine = false;
            return;
        }

        //Fechas
        $this->data = explode($delimiter,$line);

        $this->data[0] = str_replace("/","-",$this->data[0]);
        $datePart = explode("-",$this->data[0]);
        $this->dateop = dol_mktime(12,0,0,$datePart[1],$datePart[0],$datePart[2]);

        $this->dateop2 = $datePart[2]."-".$datePart[1]."-".$datePart[0];

        //Operacion: Concepto
        $this->operation=$op->getOperation($this->data[4],$defaultOperation);

        //Num. Cheque: Nro. Doc.
        //$this->num_chq=explode(" ",trim($this->data[1]));
        //$this->num_chq=$this->num_chq[count($this->num_chq)-1];
        $this->num_chq = str_replace("'","",trim($this->data[3]));

        $this->label=str_replace("\"","",$this->data[4]);
        $this->cat1=NULL;

        
        $tmpAmount = trim($this->data[5]);
//        if ($tmpAmount == "0"){
//            $tmpAmount = trim($this->data[4]);
//        }else{
//            $tmpAmount = "-".$tmpAmount;
//        }

        //eliminamos la ',' para los miles
        $this->amount= str_replace(",","",$tmpAmount);
        //$this->amount= $tmpAmount;
        
        $this->amount=(float)$this->amount;
    }

    public function processLine(){
        return $this->processLine;
    }

    public function getDateOp(){
        return $this->dateop;
    }

    public function getDateOp2(){
        return $this->dateop2;
    }

    public function getOperation(){
        return $this->operation;
    }

    public function getNumChq(){
        return $this->num_chq;
    }

    public function getLabel(){
        return $this->label;
    }

    public function getAmount(){
        return $this->amount;
    }

    public function getCat1(){
        return $this->cat1;
    }
}

?>
