<?php
require_once(DOL_DOCUMENT_ROOT."/core/class/html.formfile.class.php");
include_once $dolibarr_main_document_root."/lib/databases/".$conf->db->type.".lib.php";


class MysqlExporter {
    
    public function doExport($dolibarr_main_db_name, $dolibarr_main_db_host,$dolibarr_main_db_user,$dolibarr_main_db_port,$dolibarr_main_db_pass,$dir,$fileName) {


        $mysqldump = 'mysqldump';
        //dolibarr_set_const($db, 'SYSTEMTOOLS_MYSQLDUMP', $mysqldump, $type = 'chaine');

        create_exdir(DOL_DATA_ROOT . '/admin/temp');

        // Parameteres execution
        $command = $mysqldump;
        if (eregi(" ", $command)) $command = $command = escapeshellarg($command);	// Use quotes on command

        $param = $dolibarr_main_db_name . " -h " . $dolibarr_main_db_host;
        $param .= " -u " . $dolibarr_main_db_user;
        if (!empty($dolibarr_main_db_port)) $param .= " -P " . $dolibarr_main_db_port;

        $compression = 'none';

        $paramcrypted = $param;
        $paramclear = $param;
        if (!empty($dolibarr_main_db_pass)) {
            $paramcrypted .= " -p" . eregi_replace('.', '*', $dolibarr_main_db_pass);
            $paramclear .= " -p" . $dolibarr_main_db_pass;
        }

        $outputdir = $dir;
        $outputfile = $outputdir . '/' . $fileName;
        $outputerror = $outputfile . '.err';

//        print$langs->trans("RunCommandSummary") . ':<br>' . "\n";
//        print'<textarea rows="1" cols="120">' . $command . " " . $paramcrypted . '</textarea><br>' . "\n";
//
//        print'<br>';
//
//        print$langs->trans("BackupResult") . ': ';

        $errormsg = '';

        $result = create_exdir($outputdir);

        // Debut appel methode execution
        $fullcommandcrypted = $command . " " . $paramcrypted . " 2>&1";
        $fullcommandclear = $command . " " . $paramclear . " 2>&1";
        if ($compression == 'none') $handle = fopen($outputfile, 'w');
        if ($compression == 'gz')   $handle = gzopen($outputfile, 'w');
        if ($compression == 'bz')   $handle = bzopen($outputfile, 'w');


        if ($handle) {
            //echo "Command= ".$fullcommandcrypted."<br>";
            dol_syslog("Run command " . $fullcommandcrypted);
            $handlein = popen($fullcommandclear, 'r');
            while (!feof($handlein)) {
                $read = fgets($handlein);
                fwrite($handle, $read);
            }
            pclose($handlein);

            if ($compression == 'none') fclose($handle);
            if ($compression == 'gz')   gzclose($handle);
            if ($compression == 'bz')   bzclose($handle);

            if (!empty($conf->global->MAIN_UMASK))
                @chmod($outputfile, octdec($conf->global->MAIN_UMASK));
        }
        else {
            $langs->load("errors");
            dol_syslog("Failed to open file $outputfile", LOG_ERR);
            $errormsg = $langs->trans("ErrorFailedToWriteInDir");
        }
        // Get errorstring
        if ($compression == 'none') $handle = fopen($outputfile, 'r');
        if ($compression == 'gz')   $handle = gzopen($outputfile, 'r');
        if ($compression == 'bz')   $handle = bzopen($outputfile, 'r');
        if ($handle) {
            $errormsg = fgets($handle, 2048);	// Get 2048 first chars of error message.
            if ($compression == 'none') fclose($handle);
            if ($compression == 'gz')   gzclose($handle);
            if ($compression == 'bz')   bzclose($handle);
            if (eregi('^-- MySql', $errormsg)) $errormsg = '';	// Pas erreur
            else {
                // Renommer fichier sortie en fichier erreur
                //print "$outputfile -> $outputerror";
                dol_delete_file($outputerror);
                @rename($outputfile, $outputerror);
                // Si safe_mode on et command hors du parametre exec, on a un fichier out vide donc errormsg vide
                if (!$errormsg) $errormsg = $langs->trans("ErrorFailedToRunExternalCommand");
            }
        }
    }
}

?>
