<?php
/* Copyright (C) 2007 Laurent Destailleur  <eldy@users.sourceforge.net>
 * Copyright (C) ---Put here your own copyright and developer email---
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

/**
 *   	\file       dev/skeletons/skeleton_page.php
 *		\ingroup    mymodule othermodule1 othermodule2
 *		\brief      This file is an example of a php page
 *		\version    $Id: skeleton_page.php,v 1.8 2009/03/09 11:28:12 eldy Exp $
 *		\author		Put author name here
 *		\remarks	Put here some comments
 */
require("./pre.inc.php");
require_once(DOL_DOCUMENT_ROOT."/lib/admin.lib.php");
require_once(DOL_DOCUMENT_ROOT."/MCCImport/mccimport_rule_category.class.php");
require_once(DOL_DOCUMENT_ROOT."/MCCImport/mccimport_rule.class.php");

$langs->load("companies");
$langs->load("bills");
$langs->load("other");

//require_once(DOL_DOCUMENT_ROOT."/../dev/skeletons/skeleton_class.class.php");
if (!$user->admin)
accessforbidden();

if (!isset($_REQUEST['selectedCategory'])) {
    echo "Seleccione una categoria";
    return;
}

$selectedCategory=new mccImport_rule_category($db);


$result = $selectedCategory->fetch($_REQUEST['selectedCategory']);

if ($result < 0) dol_print_error($db,$myobject->error);


if (isset($_POST['action']) && $_POST['action'] == "addRule"){
    $ruleOrder = $_POST['ruleOrder'];
    $pattern = $_POST['rulePattern'];
    $operation = $_POST['operation'];

    

    $rule=new Mccimport_rule($db);
    $rule->ruleOrder=$ruleOrder;
    $rule->pattern=$pattern;
    $rule->categoryId=$selectedCategory->id;
    $rule->operationId=$operation;

    $result = $rule->create(NULL);
    if ($result < 0) dol_print_error($db,$myobject->error);
}

if (isset($_POST['action']) && $_POST['action'] == "modifyRule"){
    $ruleOrder = $_POST['hiddenOrder'];
    $pattern = $_POST['hiddenPattern'];
    $operation = $_POST['hiddenOperation'];
    $id = $_POST['hiddenId'];



    $rule=new mccImport_rule($db);
    $rule->id=$id;
    $rule->ruleOrder=$ruleOrder;
    $rule->pattern=$pattern;
    $rule->categoryId=$selectedCategory->id;
    $rule->operationId=$operation;

    $result = $rule->update(NULL);
    if ($result < 0) dol_print_error($db,$myobject->error);
}

if (isset($_POST['action']) && $_POST['action'] == "deleteRule"){
    $rule=new Mccimport_rule($db);
    $rule->id = $_POST['hiddenId'];
    $result = $rule->delete(NULL);
    if ($result < 0) dol_print_error($db,$rule->error);

}

$categories = array();

$resql=$db->query("Select * from llx_mccImport_rule_category");
if ($resql) {
    $num = $db->num_rows($resql);
    $i = 0;
    if ($num) {
        while ($i < $num) {
            $obj = $db->fetch_object($resql);
            if ($obj) {
                $categories[] = $obj;
            }
            $i++;
        }
    }
}

$rules = array();
$resql=$db->query("Select * from llx_mccImport_rule where categoryId= ".$selectedCategory->id." order by ruleOrder asc");
if ($resql) {
    $num = $db->num_rows($resql);
    $i = 0;
    if ($num) {
        while ($i < $num) {
            $obj = $db->fetch_object($resql);
            if ($obj) {
                $rules[] = $obj;
            }
            $i++;
        }
    }
}

$maxOrder = 0;
if (!empty($rules)){
    $maxOrder = $rules[count($rules)-1]->ruleOrder;
    $maxOrder += 1;
}

$deleteImgSrc = DOL_URL_ROOT."/MCCImport/img/delete.png";
$updateImgSrc = DOL_URL_ROOT."/MCCImport/img/update.png";




$form=new Form($db);
?>

<html>
<head>

    <link rel="stylesheet" type="text/css" title="default" href="<?php echo DOL_URL_ROOT; ?>/theme/eldy/eldy.css.php">

    <script type="text/javascript">
        function agregarRegla(){
            var frm = window.document.getElementById('frm');
            var txtAction = window.document.getElementById('action');
            var cboOrder = window.document.getElementById('ruleOrder');
            var txtPattern = window.document.getElementById('rulePattern');
            var cboOperation = window.document.getElementsByName('operation')[0];



            if (txtPattern.value == ""){
                alert ("Debe ingresar un patron para la Regla");
                txtPattern.focus();
                return;
            }

            if (cboOperation.value < 1){
                alert ("Debe seleccionar una operacion para la Regla");
                cboOperation.focus();
                return;
            }

            

            txtAction.value = "addRule";

            frm.submit();
        }

        function modificarRegla(id){
            var frm = window.document.getElementById('frm');
            var txtAction = window.document.getElementById('action');
            var cboOrder = window.document.getElementById('ruleOrder'+id);
            var txtPattern = window.document.getElementById('rulePattern'+id);
            var cboOperation = window.document.getElementsByName('operation'+id)[0];

            var hiddenId = window.document.getElementById('hiddenId');
            var hiddenOrder = window.document.getElementById('hiddenOrder');
            var hiddenPattern = window.document.getElementById('hiddenPattern');            
            var hiddenOperation = window.document.getElementById('hiddenOperation');


            if (txtPattern.value == ""){
                alert ("Debe ingresar un patron para la Regla");
                txtPattern.focus();
                return;
            }

            if (cboOperation.value < 1){
                alert ("Debe seleccionar una operacion para la Regla");
                cboOperation.focus();
                return;
            }

            if (confirm("Esta seguro que desea modificar la regla seleccionada?")){
                hiddenId.value = id;
                hiddenOrder.value = cboOrder.value;
                hiddenPattern.value = txtPattern.value;
                hiddenOperation.value = cboOperation.value;
                txtAction.value = "modifyRule";
                
                frm.submit();
            }


        }

        function eliminarRegla(id){
            var frm = window.document.getElementById('frm');
            var txtAction = window.document.getElementById('action');
            var txtHiddenId = window.document.getElementById('hiddenId');



            if (confirm("Esta seguro que desea eliminar la regla seleccionada?")){
                txtAction.value = "deleteRule";
                txtHiddenId.value = id;
                frm.submit();
            }
        }

        function changeCategory(){
            var cboCategoria = window.document.getElementById('idCategoria');

            
            window.document.location.href="<?php echo $_SERVER['PHP_SELF'];?>?selectedCategory="+cboCategoria.value;

        }
    </script>
</head>
    <body>
        <form action="<?php echo $_SERVER["PHP_SELF"];?>" method="post" id="frm">
        <input type="hidden" name="selectedCategory" value="<?php echo $selectedCategory->id ?>"/>
        <input type="hidden" name="action" id="action" value=""/>
        <input type="hidden" name="hiddenId" id="hiddenId" value=""/>
        <input type="hidden" name="hiddenOrder" id="hiddenOrder" value=""/>
        <input type="hidden" name="hiddenPattern" id="hiddenPattern" value=""/>
        <input type="hidden" name="hiddenOperation" id="hiddenOperation" value=""/>
        <table>
            <tr class="liste_titre">
                <td>
                    Categor&iacute;a:&nbsp;&nbsp;
                    <select id="idCategoria" onchange="changeCategory();" class="flat">
                        <?php
                        foreach ($categories as $c) {
                            ?>
                        <option value="<?php echo($c->id);?>" <?php echo (($c->id == $selectedCategory->id)?"selected":""); ?>><?php echo($c->name);?></option>
                        <?php
                    }
                    ?>
                    </select>
                </td>
            </tr>            
            <tr>
                <td>
                    Reglas:
                </td>
            </tr>
            <tr>
                <td>
                    <table height="100%" >
                        <tr align="center" class="liste_titre">
                        <td>
                            Orden
                        </td>
                        <td>
                            Patr&oacute;n
                        </td>
                        <td>
                            Operaci&oacute;n
                        </td>
                        <td>
                            Acci&oacute;n
                        </td>
                        </tr>
                    
            <?php
            foreach ($rules as $r){
            ?>
                <tr>
                    <td>
                        <input type="hidden" name="idRule<?php echo($r->id);?>" value="<?php echo($r->id);?>"/>
                        <select id="ruleOrder<?php echo($r->id);?>" name="ruleOrder<?php echo($r->id);?>" class="flat">
                        <?php
                        for ($i=0; $i<=$maxOrder;$i++) {
                            ?>
                        <option value="<?php echo($i);?>" <?php echo (($r->ruleOrder == $i)?"selected":""); ?>><?php echo($i);?></option>
                        <?php
                        }
                        ?>
                        </select>
                    </td>
                    <td>
                        <input type="text" name="rulePattern<?php echo($r->id);?>"  id="rulePattern<?php echo($r->id);?>" value="<?php echo($r->pattern);?>"/>
                    </td>
                    <td>
                        <?php $form->select_types_paiements($r->operationId,'operation'.$r->id,'1,2',2,1);?>
                    </td>                
                    <td>                        
                        <img align="middle" src="<?php echo $updateImgSrc;?>" border="0" onclick="modificarRegla('<?php echo($r->id);?>');" style="cursor:pointer;">
                        <img align="middle" src="<?php echo $deleteImgSrc;?>" border="0" onclick="eliminarRegla('<?php echo($r->id);?>');" style="cursor:pointer;">
                    </td>
                </tr>
            <?php
            }
            ?>
                <tr>
                    <td>
                        <select id="ruleOrder" name="ruleOrder" class="flat">
                        <?php
                        for ($i=0; $i<=$maxOrder;$i++) {
                            ?>
                        <option value="<?php echo($i);?>" <?php echo(($i == $maxOrder)?"selected":""); ?>  ><?php echo($i);?></option>
                        <?php
                        }
                        ?>
                        </select>
                    </td>
                    <td>
                        <input type="text" name="rulePattern" id="rulePattern" value=""/>
                    </td>
                    <td>
                        <?php $form->select_types_paiements('','operation','1,2',2,1); ?>
                    </td>                
                    <td>
                        <input type="button" value="Agregar" onclick="agregarRegla();">
                    </td>
                </tr>
            </table>
                </td>
            </tr>
        </table>
        </form>
    </body>
</html>