<?php
/* Copyright (C) 2007 Laurent Destailleur  <eldy@users.sourceforge.net>
 * Copyright (C) ---Put here your own copyright and developer email---
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

/**
 *   	\file       dev/skeletons/skeleton_page.php
 *		\ingroup    mymodule othermodule1 othermodule2
 *		\brief      This file is an example of a php page
 *		\version    $Id: skeleton_page.php,v 1.8 2009/03/09 11:28:12 eldy Exp $
 *		\author		Put author name here
 *		\remarks	Put here some comments
 */
require("./pre.inc.php");
//require_once(DOL_DOCUMENT_ROOT."/../dev/skeletons/skeleton_class.class.php");
require_once(DOL_DOCUMENT_ROOT."/compta/bank/class/account.class.php");
require_once(DOL_DOCUMENT_ROOT."/MCCImport/OperationProcessor.class.php");
require_once(DOL_DOCUMENT_ROOT."/MCCImport/Parser.class.php");
require_once(DOL_DOCUMENT_ROOT."/MCCImport/FrancesParser.class.php");
require_once(DOL_DOCUMENT_ROOT."/MCCImport/GaliciaParser.class.php");
require_once(DOL_DOCUMENT_ROOT."/MCCImport/MysqlExporter.class.php");


// Load traductions files requiredby by page
$langs->load("companies");
$langs->load("bills");
$langs->load("other");

// Get parameters
$myparam = isset($_GET["myparam"])?$_GET["myparam"]:'';

// Protection if external user
if ($user->societe_id > 0) {
    accessforbidden();
}



$exportDir = "";
$fh = fopen($conf->user->dir_output."/MCCImportExportDir.txt", 'a+') or die("can't open file ".$conf->user->dir_output."/MCCImportExportDir.txt");
if(filesize($conf->user->dir_output."/MCCImportExportDir.txt") > 0){
    $exportDir = trim(fread($fh, filesize($conf->user->dir_output."/MCCImportExportDir.txt")));
}
fclose($fh);


/*******************************************************************
* ACTIONS
*
* Put here all code to do according to value of "action" parameter
********************************************************************/

llxHeader('','','');


$backupComplete = false;

if ($_REQUEST["action"] == 'backup') {
    echo  $_REQUEST["exportDir"];
    //saves the entered dir
    $exportDir = $_REQUEST["exportDir"];
    $fh = fopen($conf->user->dir_output."/MCCImportExportDir.txt", 'w') or die("can't open file".$conf->user->dir_output."/MCCImportExportDir.txt");
    fwrite($fh, trim($exportDir));
    fclose($fh);


    //makes the backup
    $fileName = "Dolibarr_".date("Ymd",time()).".sql";

    //deletes any old error file
    @unlink($exportDir."/".$fileName.".err");


    $exporter = new MysqlExporter();
    $exporter->doExport($dolibarr_main_db_name, $dolibarr_main_db_host,$dolibarr_main_db_user,$dolibarr_main_db_port,$dolibarr_main_db_pass,$exportDir,$fileName);

    $backupComplete=true;
    if (file_exists($exportDir."/".$fileName.".err")){
        $backupMessage="<font color=\"red\">Se produjo un error realizando el backup. Revise el archivo <b>".$exportDir."/".$fileName.".err</b></font>";
    }else{
        $backupMessage="<font color=\"green\">El Backup fue realizado exitosamente en <b>".$exportDir."/".$fileName."</b></font>";
    }


}else if ($_REQUEST["action"] == 'import') {

    $account = $_REQUEST['account'];

    if (isset($_REQUEST[separatorTAB])) {
        $delimiter = "\t";
    } else if (isset($_REQUEST[separator]) && trim($_REQUEST[separator]) != "") {
        $delimiter = trim($_REQUEST[separator]);
    } else {
        print ('<font color="red">DEBE ELEGIR EL DELIMITADOR DE CAMPO!</font><br><br>');
        print ('<input type="button" value="Volver" onclick="history.back()"');
        exit;
    }


    $file = fopen($_FILES['uploadFile']['tmp_name'], "r");

    if (isset($_REQUEST['omitFirst'])) {
        //salteamos la primer linea.
        fgets($file);
    }

    $db->begin();
    $line = "";
    $count = 0;
    $html = "<table class='notopnoleftnoright' style='margin:20px'><tr class='liste_titre'><td>#</td><td>Registros</td><td>Operaci&oacute;n</td><td>Monto</td><td>Estado</td></tr>";

    $defaultOperation=$_REQUEST['operation'];


    $op = new OperationProcessor($_POST['idCategoria'],$db);


    $parsedData = array();
    $toConciliate = array();

    while (($line = fgets($file))!= "") {

        $line = trim($line);
        if ($line == "") {
            continue;
        }

        $parser = null;

        $ff = explode (".",$_FILES['uploadFile']['name']);
        if ($ff[1] == "asp"){
            $parser = new GaliciaParser($line,$delimiter,$op,$defaultOperation);
        }else{
            $parser = new FrancesParser($line,$delimiter,$op,$defaultOperation);
        }

        if (!$parser->processLine()){
            continue;
        }

        $dateop = $parser->getDateOp();

        $dateop2 = $parser->getDateOp2();

        $operation= $parser->getOperation();

        $num_chq=$parser->getNumChq();

        $label=$parser->getLabel();
        $cat1=$parser->getCat1();

        $amount = $parser->getAmount();
        
        $numReleve = $parser->getNumReleve();

        $html .= "<tr class='".(($count%2==0)?"pair":"impair")."'><td style='padding:5px'><b>".($count+1)."</b></td><td style='padding:5px'>";
        $html .= $line."(Num Releve: '".$numReleve."', Date: '".$dateop2."')</td><td style='padding:5px'>";
        $html .= $operation."</td><td style='padding:5px'>";
        $html .= $amount."</td><td style='padding:5px'>";


        //ME fijo si ya existe el movimiento en la BD
        $exist = false;
        if ($parser->getOperation() == "CHQ"){
            if ($amount > 0){
                //$html.= "Select rowid, fk_user_author, fk_type,rappro from llx_bank where fk_type= '".$parser->getOperation()."' AND fk_account = ".$account." AND amount = ".$amount." AND datev BETWEEN (STR_TO_DATE('".$dateop2."', '%Y-%m-%d') - INTERVAL 30 DAY) AND (STR_TO_DATE('".$dateop2."', '%Y-%m-%d') + INTERVAL 30 DAY)";
                //mismo tipo de movimiento, misma cuenta, mismo monto, mismo numero de cheque y fecha entre la que dice el banco y +-35 dias
                $exist = $db->query("Select rowid, fk_user_author, fk_type,rappro from llx_bank where fk_type= '".$parser->getOperation()."' AND fk_account = ".$account." AND amount = ".$amount." AND datev BETWEEN (STR_TO_DATE('".$dateop2."', '%Y-%m-%d') - INTERVAL 35 DAY) AND (STR_TO_DATE('".$dateop2."', '%Y-%m-%d') + INTERVAL 35 DAY)");
            }else{
                //mismo tipo de movimiento, misma cuenta, mismo monto, mismo numero de cheque y fecha entre la que dice el banco y 35 dias para atras
                $exist = $db->query("Select rowid, fk_user_author, fk_type,rappro from llx_bank where fk_type= '".$parser->getOperation()."' AND fk_account = ".$account." AND amount = ".$amount." AND num_chq = '".$num_chq."' AND datev BETWEEN (STR_TO_DATE('".$dateop2."', '%Y-%m-%d') - INTERVAL 35 DAY) and '".$dateop2."'");
            }
        }else if ($parser->getOperation() == "EFE" || $parser->getOperation() == "HAB" ){
            //mismo tipo de movimiento, misma cuenta, mismo monto y fecha entre la que dice el banco y 4 dias para atras
            $exist = $db->query("Select rowid, fk_user_author, fk_type,rappro from llx_bank where fk_type= '".$parser->getOperation()."' AND fk_account = ".$account." AND amount = ".$amount." AND datev BETWEEN (STR_TO_DATE('".$dateop2."', '%Y-%m-%d') - INTERVAL 4 DAY) and '".$dateop2."'");
        }else if ($parser->getOperation() == "TRN" ){
            //$html.="Select rowid, fk_user_author, fk_type,rappro from llx_bank where fk_type= '".$parser->getOperation()."' AND fk_account = ".$account." AND amount = ".$amount." AND datev BETWEEN (STR_TO_DATE('".$dateop2."', '%Y-%m-%d') - INTERVAL 4 DAY) and '".$dateop2."' AND (note is null || note = '' || note = '".$label."')";
            //mismo tipo de movimiento, misma cuenta, mismo monto, nota igual o vacia y fecha entre la que dice el banco y 4 dias para atras
            $exist = $db->query("Select rowid, fk_user_author, fk_type,rappro from llx_bank where fk_type= '".$parser->getOperation()."' AND fk_account = ".$account." AND amount = ".$amount." AND datev BETWEEN (STR_TO_DATE('".$dateop2."', '%Y-%m-%d') - INTERVAL 4 DAY) and '".$dateop2."' AND (note is null || note = '' || note = '".$label."')");
        }else{
            $exist = $db->query("Select rowid, fk_user_author, fk_type,rappro from llx_bank where datev ='".$dateop2."' AND fk_account = ".$account." AND label = '".$label."' AND amount = ".$amount." AND num_chq = '".$num_chq."'");
        }

        if ($db->num_rows($exist) == 0) {  // <-- No existe en la BD
            if ($parser->getOperation() == "CHQ" || $parser->getOperation() == "EFE" || $parser->getOperation() == "HAB" || $parser->getOperation() == "TRN"){
                $conciliar = false;
                $insertObject = array ($dateop2, $dateop, $operation, $label, $amount, $num_chq, $cat1, $user,$conciliar,$line,$numReleve);
                $parsedData[] = $insertObject;
                $html .= "<font color='red'><b>NUEVO SIN CONCILIAR</b></font></td></tr>";
            }else{
                $conciliar = true;
                $insertObject = array ($dateop2, $dateop, $operation, $label, $amount, $num_chq, $cat1, $user,$conciliar,$line,$numReleve);
                $parsedData[] = $insertObject;
                $html .= "<font color='green'><b> NUEVO A CONCILIAR</b></font></td></tr>";
            }
        }else { // <-- Existe en la BD
            $obj = $db->fetch_object($exist);
            if ($obj->fk_type == "CHQ" || $parser->getOperation() == "EFE" || $obj->fk_type == "HAB" || $obj->fk_type == "TRN"){
                if ($obj->rappro == 1){
                    $html .= "<font color='blue'><b>DUPLICADO</b></font></td></tr>";
                }else if ($obj->fk_user_author > 0){ // <-- El autor no es el importador
                    
                    if ($obj->fk_type == "TRN" && $db->num_rows($exist) > 1){ // Si es TRN y hay mas de 2 registros que matchean en la bd, entonces no concilio. Que alguien se haga cargo manualmente
                        $conciliar = false;
                        $insertObject = array ($dateop2, $dateop, $operation, $label, $amount, $num_chq, $cat1, $user,$conciliar,$line,$numReleve);
                        $parsedData[] = $insertObject;
                        $html .= "<font color='green'><b>EXISTENTE SIN CONCILIAR (".$db->num_rows($exist)." registros iguales)</b></font></td></tr>";
                    }else{
                        $o = array ($obj->rowid, $operation,$line,$ammount,$numReleve,$dateop2, $label);
                        $toConciliate[] = $o;
                        $html .= "<font color='orange'><b>EXISTENTE A CONCILIAR</b></font></td></tr>";
                    } 
                }else{
                    $html .= "<font color='blue'><b>DUPLICADO</b></font></td></tr>";
                }
            }else{
                $o = array ($obj->rowid, $operation,$line, $ammount,$numReleve,$dateop2, $label);
                $toConciliate[] = $o;
                $html .= "<font color='blue'><b>DUPLICADO</b></font></td></tr>";
            }
        }

        $count++;
    }

    $_SESSION['parsedData']=$parsedData;
    $_SESSION['toConciliate']=$toConciliate;

    //$db->commit();
    $html .= "</table>";

    print ($html);

    print ("<form method='POST' id='frmCommit'>");
    print ('<input type="hidden" name="account" value="'.$account.'">');
    print ('<input type="hidden" name="action" value="commit">');
    print ('<br><br><input type="button" value="Volver" onclick="window.location.href=\'./index.php\'">');
    print ('&nbsp;&nbsp;<input type="button" value="Confirmar" onclick="if(confirm(\'Desea confirmar la transaccion?\')){window.document.getElementById(\'frmCommit\').submit();}">');
    print ("</form>");
    exit;

} else if ($_REQUEST["action"] == 'commit') {

    if (!isset ($_SESSION['parsedData'])) {
        print('ERROR: No parsed data!');
        return;
    }
    if (!isset ($_REQUEST['account'])) {
        print('ERROR: No account selected!');
        return;
    }

    $db->begin();

    $account = $_REQUEST['account'];
    $data = $_SESSION['parsedData'];

    $acct=new Account($db,$account);

    $html = "<table class='notopnoleftnoright' style='margin:20px'><tr class='liste_titre'><td>#</td><td>Registro</td><td>Operaci&oacute;n</td><td>Monto</td><td>Estado</td></tr>";

    $fail = false;
    $count = 0;
    foreach ($data as $d) {
        $dateop2=$d[0];
        $dateop=$d[1];
        $operation=$d[2];
        $label=$d[3];
        $amount=$d[4];
        $num_chq=$d[5];
        $cat1=$d[6];
        $user=$d[7];
        $conciliar=$d[8];
        $line=$d[9];
        $numeReleve=$d[10];

        $html .= "<tr class='".(($count%2==0)?"pair":"impair")."'><td style='padding:5px'><b>".($count+1)."</b></td><td style='padding:5px'>";
        $html .= $line."</td><td style='padding:5px'>";
        $html .= $operation."</td><td style='padding:5px'>";
        $html .= $amount."</td><td style='padding:5px'>";

        $exist = false;
        
        if ($operation == "CHQ"){
            if ($amount > 0){
                //mismo tipo de movimiento, misma cuenta, mismo monto, mismo numero de cheque y fecha entre la que dice el banco y +-35 dias
                $exist = $db->query("Select rowid, fk_user_author, fk_type,rappro from llx_bank where fk_type= '".$operation."' AND fk_account = ".$account." AND amount = ".$amount." AND datev BETWEEN (STR_TO_DATE('".$dateop2."', '%Y-%m-%d') - INTERVAL 35 DAY) AND (STR_TO_DATE('".$dateop2."', '%Y-%m-%d') + INTERVAL 35 DAY)");
            }else{
                //mismo tipo de movimiento, misma cuenta, mismo monto, mismo numero de cheque y fecha entre la que dice el banco y 35 dias para atras
                $exist = $db->query("Select rowid, fk_user_author, fk_type,rappro from llx_bank where fk_type= '".$operation."' AND fk_account = ".$account." AND amount = ".$amount." AND num_chq = '".$num_chq."' AND datev BETWEEN (STR_TO_DATE('".$dateop2."', '%Y-%m-%d') - INTERVAL 35 DAY) and '".$dateop2."'");
            }
        }else if ($operation == "EFE" || $operation == "HAB" ){
            //mismo tipo de movimiento, misma cuenta, mismo monto y fecha entre la que dice el banco y 4 dias para atras
            $exist = $db->query("Select rowid, fk_user_author, fk_type,rappro from llx_bank where fk_type= '".$operation."' AND fk_account = ".$account." AND amount = ".$amount." AND datev BETWEEN (STR_TO_DATE('".$dateop2."', '%Y-%m-%d') - INTERVAL 4 DAY) and '".$dateop2."'");
        }else if ($operation == "TRN" ){
            //mismo tipo de movimiento, misma cuenta, mismo monto, nota igual o vacia y fecha entre la que dice el banco y 4 dias para atras
            $exist = $db->query("Select rowid, fk_user_author, fk_type,rappro from llx_bank where fk_type= '".$operation."' AND fk_account = ".$account." AND amount = ".$amount." AND datev BETWEEN (STR_TO_DATE('".$dateop2."', '%Y-%m-%d') - INTERVAL 4 DAY) and '".$dateop2."' AND (note is null || note = '' || note = '".$label."')");
        }else{
            $exist = $db->query("Select rowid, fk_user_author, fk_type,rappro from llx_bank where datev ='".$dateop2."' AND fk_account = ".$account." AND label = '".$label."' AND amount = ".$amount." AND num_chq = '".$num_chq."'");
        }
        

        if ($db->num_rows($exist) == 0) { // <-- No existe en la BD
            $insertid = $acct->addline($dateop, $operation, $label, $amount, $num_chq, $cat1, $user);
            if ($insertid <= 0) {
                //dol_print_error($db,$acct->error);
                $db->rollback();
                $html .= "<font color='red'><b>ERROR</b></font></td></tr>";
                $fail = true;
                break;
            }

            
            $db->query("update llx_bank set num_releve = '".$numeReleve."', note='".$label."' where rowid = ".$insertid);
            if ($conciliar){
                $db->query("update llx_bank set rappro = 1, datev = '".$dateop2."'  where rowid = ".$insertid);
                $html .= "<font color='orange'><b>CONCILIADO</b></font></td></tr>";
            }else{
                $html .= "<font color='green'><b>OK</b></font></td></tr>";
            }

        }else { // <-- Existe en la BD
            $html .= "<font color='blue'><b>DUPLICADO</b></font></td></tr>";
        }

        $count++;
    }

    $data = $_SESSION['toConciliate'];
    foreach ($data as $d) {
        $html .= "<tr class='".(($count%2==0)?"pair":"impair")."'><td style='padding:5px'><b>".($count+1)."</b></td><td style='padding:5px'>";
        $html .= $d[2]."</td><td style='padding:5px'>";
        $html .= $d[1]."</td><td style='padding:5px'>";
        $db->query("update llx_bank set rappro = 1, num_releve='".$d[4]."', datev = '".$d[5]."', note='".$d[6]."'  where rowid = ".$d[0]);
        $html .= "<font color='orange'><b>CONCILIADO</b></font></td></tr>";
        $count++;
    }

    $db->commit();
    $html .= "</table>";

    print ($html);

    if ($fail) {
        dol_print_error($db,$acct->error);
    }else{
        print("<font color='green'><b>IMPORTACION EFECTUADA CORRECTAMENTE!</b></font>");
    }
    print ('<br><br><input type="button" value="Volver" onclick="window.location.href=\'./index.php\'">');

    exit;


}else {
    $_SESSION['parsedData'] = "";
    $_SESSION['toConciliate'] = "";
}





/***************************************************
* PAGE
*
* Put here all code to build page
****************************************************/





print_fiche_titre("Importacion de Archivos");



$accounts = array();

$resql=$db->query("Select * from llx_bank_account");
if ($resql) {
    $num = $db->num_rows($resql);
    $i = 0;
    if ($num) {
        while ($i < $num) {
            $obj = $db->fetch_object($resql);
            if ($obj) {
                $accounts[] = $obj;
            }
            $i++;
        }
    }
}

$accountsNames = array();
foreach ($accounts as $a){
    $accountsNames[$a->rowid] = $a->label;
}

$ruleCategories = array();

$resql=$db->query("Select * from llx_mccImport_rule_category");
if ($resql) {
    $num = $db->num_rows($resql);
    $i = 0;
    if ($num) {
        while ($i < $num) {
            $obj = $db->fetch_object($resql);
            if ($obj) {
                $ruleCategories [] = $obj;
            }
            $i++;
        }
    }
}


?>
<script type="text/javascript">
    function submitForm(){

        var txtAccount = window.document.getElementById('account');
        var cboTipo = window.document.getElementsByName('operation')[0];
        var uploadFile= window.document.getElementById('uploadFile');
        var action= window.document.getElementById('action');
        var chkDelimiter = window.document.getElementById('separatorTAB');
        var txtDelimiter = window.document.getElementById('separator');

        var cboCat = window.document.getElementById('idCategoria');
        var opt = cboCat.options[cboCat.selectedIndex];

        if (cboCat.value == "-"){
            alert ("Debe seleccionar un grupo de reglas!");
            cboTipo.focus();
            return;
        }

        if (cboTipo.value == ""){
            alert ("Debe seleccionar un tipo de operacion!");
            cboTipo.focus();
            return;
        }

        if (uploadFile.value == ""){
            alert ("Debe seleccionar un archivo a importar");
            uploadFile.focus();
            return;
        }

        if (!chkDelimiter.checked && txtDelimiter.value == ""){
            alert ("Debe ingresar un delimitador");
            txtDelimiter.focus();
            return;
        }


//        if (!confirm('Esta seguro que desea importar el archivo seleccionado a la cuenta '+opt.getAttribute("accountname")+'?')){
//            return;
//        }

        txtAccount.value = opt.getAttribute("accountid");

        if (txtAccount.value == ""){
            alert ("Usted no configuro ninguna cuenta bancaria para el grupo de reglas seleccionado!");
            return;
        }

        var frm = window.document.getElementById('importForm');
        action.value = 'import';
        frm.submit();

    }

    function makeBackup(){
        var rta = prompt("Indique el directorio donde desea guardar el backup?", "<?=$exportDir?>");
        if (rta){
            var action= window.document.getElementById('action');
            var exportDir= window.document.getElementById('exportDir');
            var frm = window.document.getElementById('importForm');

            action.value = 'backup';
            exportDir.value = rta;

            frm.submit();
        }
    }

    function ruleCategoryChanged(){
        var cboCat = window.document.getElementById('idCategoria');
        var txtAccount = window.document.getElementById('account');
        var divAccount = window.document.getElementById('accountDiv');

        var opt = cboCat.options[cboCat.selectedIndex];

        divAccount.innerHTML = "(Cuenta: <b>"+opt.getAttribute("accountname")+"</b>)";
        txtAccount.value = opt.getAttribute("accountid");
    }
</script>
<?php

$form=new Form($db);



print '<form method="post" action="'.DOL_URL_ROOT.'/MCCImport/index.php" id="importForm" enctype="multipart/form-data">';

?>

<input type="hidden" name="action" id="action"/>
<input type="hidden" name="exportDir" id="exportDir"/>
<input type="hidden" name="account" id="account"/>

<table border="0" class="notopnoleftnoright" width="100%">
    <tr><td width="50%">
<table border="0" class="notopnoleftnoright">
    <tr>
        <td valign="top" class="notopnoleft">
	Grupo de Reglas:
        </td>
        <td valign="top" class="notopnoleft" nowrap="true">
            <select name="idCategoria" id="idCategoria" class="flat" onchange="ruleCategoryChanged();">
                <option value="-">--Seleccione--</option>
                <?php
                foreach ($ruleCategories as $c) {
                    ?>
                <option value="<?php echo($c->id);?>" accountid="<?php echo($c->accountId);?>" accountname="<?php echo($accountsNames[$c->accountId]);?>"  ><?php echo($c->name);?></option>
                    <?php
                }
                ?>
            </select>
            &nbsp;<div id="accountDiv"></div>
        </td>
    </tr>


    <tr>
        <td valign="top" class="notopnoleft">
	Tipo de Transaccion por defecto:
        </td>
        <td valign="top" class="notopnoleft" nowrap="true">
            <table cellpadding="0" cellspacing="0" border="0">
                <tr>
                    <td>
                        <?php $form->select_types_paiements('MOV','operation','1,2',2,1); ?>
                    </td>
                    <td style="padding-left:5px;">
                        <?php print $form->textwithhelp('',"Todas las transacciones que no concuerdan con ninguna regla seran cargadas con este tipo.",3); ?>
                    </td>
                </tr>
            </table>
        </td>
    </tr>
    <tr>
        <td valign="top" class="notopnoleft">
	Seleccione el archivo a importar:
        </td>
        <td valign="top" class="notopnoleft">
            <input type="file" name="uploadFile" id="uploadFile"/>
        </td>
    </tr>
    <tr>
        <td valign="top" class="notopnoleft">
	Omitir primer l&iacute;nea:
        </td>
        <td valign="top" class="notopnoleft">
            <table cellpadding="0" cellspacing="0" border="0">
                <tr>
                    <td>
                        <input type="checkbox" name="omitFirst" id="omitFirst" checked/>
                    </td>
                    <td style="padding-left:5px;">
                        <?php print $form->textwithhelp('',"Elija esta opcion cuando la primer linea del archivo deba ser omitida debido a que contiene el encabezado en vez de datos.",3); ?>
                    </td>
                </tr>
            </table>

        </td>
    </tr>
    <tr>
        <td valign="top" class="notopnoleft">
	Delimitador de campo:
        </td>
        <td valign="top" class="notopnoleft">
            <table cellpadding="0" cellspacing="0" border="0">
                <tr>
                    <td>
                        <input type="checkbox" name="separatorTAB" id="separatorTAB" checked onchange="window.document.getElementById('separator').value = '';"/>&nbsp;TAB.
                    </td>
                    <td>
                        &nbsp;Otro: &nbsp;<input type="text" name="separator" id="separator" onkeydown="window.document.getElementById('separatorTAB').checked = false;" />
                    </td>
                    <td style="padding-left:5px;">
                        <?php print $form->textwithhelp('',"Seleccione el separador de campos utilizado en el archivo. Si el caracter es TAB, utilice el checkbox; sino ingreselo en el campo de texto.",3); ?>
                    </td>
                </tr>
            </table>

        </td>

    </tr>
    <tr>

        <td valign="top" class="notopnoleft" colspan="2" style="text-align:center">

            <input type="button" value="Importar" onclick="submitForm();"/>
        </td></tr>
    </table>
        </td><td valign="top">
         <table border="0" class="notopnoleftnoright">
            <tr><td valign="top" class="notopnoleft">
                    <?php
                    if ($backupComplete){
                    ?>
                        <?=$backupMessage?>
                    <?php
                    }else{
                    ?>
                        <b>Guardar Backup:&nbsp;</b><input type="button" value="Generar Archivo" onclick="makeBackup();"/>
                    <?php
                    }
                    ?>
                </td></tr>
         </table>
    </td></tr>
       </table>
</form>
<?php



// End of page
$db->close();
llxFooter('$Date: 2009/03/09 11:28:12 $ - $Revision: 1.8 $');

?>
<script type="text/javascript">
    ruleCategoryChanged();
</script>
