<?php
/* Copyright (C) 2004      Rodolphe Quiedeville <rodolphe@quiedeville.org>
 * Copyright (C) 2004-2008 Laurent Destailleur  <eldy@users.sourceforge.net>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

/**
            \file       htdocs/admin/taxes.php
        \ingroup    tax
        \brief      Page de configuration du module tax
                \version    $Id: taxes.php,v 1.2 2008/11/04 17:26:33 eldy Exp $
*/

//require('./pre.inc.php');
require("../main.inc.php");
require_once(DOL_DOCUMENT_ROOT."/lib/admin.lib.php");
require_once(DOL_DOCUMENT_ROOT."/MCCImport/mccimport_rule_category.class.php");

if (!$user->admin)
accessforbidden();


$accounts = array();

$resql=$db->query("Select * from llx_bank_account");
if ($resql) {
    $num = $db->num_rows($resql);
    $i = 0;
    if ($num) {
        while ($i < $num) {
            $obj = $db->fetch_object($resql);
            if ($obj) {
                $accounts[] = $obj;
            }
            $i++;
        }
    }
}

if (isset($_POST['action']) && $_POST['action'] == "addCategory") {
    $name = $_POST['newCategoryName'];
    $accountId = $_POST['account'];
    $cat=new Mccimport_rule_category($db);
    $cat->name=$name;
    $cat->accountId=$accountId;

    $result = $cat->create(NULL);
    if ($result < 0) dol_print_error($db,$myobject->error);

} else if (isset($_POST['action']) && $_POST['action'] == "modifyCategory") {
    $id = $_POST['currentCategoryId'];
    $name = $_POST['currentCategoryName'];
    $accountId = $_POST['currentAccount'];

    $cat=new Mccimport_rule_category($db);
    $cat->id=$id;
    $cat->name=$name;
    $cat->accountId=$accountId;

    $result = $cat->update(NULL);
    if ($result < 0) dol_print_error($db,$myobject->error);
} else if (isset($_POST['action']) && $_POST['action'] == "deleteCategory") {

    $id = $_POST['currentCategoryId'];

    $resql=$db->query("delete from llx_mccImport_rule where categoryId = ".$id);
    if (!$resql) {
        dol_print_error($db);
        return;
    }



    $cat=new Mccimport_rule_category($db);
    $cat->id=$id;

    $result = $cat->delete(NULL);
    if ($result < 0) dol_print_error($db,$myobject->error);
}




/*
 * View
 */

llxHeader();

$categories = array();

$resql=$db->query("Select * from llx_mccImport_rule_category");
if ($resql) {
    $num = $db->num_rows($resql);
    $i = 0;
    if ($num) {
        while ($i < $num) {
            $obj = $db->fetch_object($resql);
            if ($obj) {
                $categories[] = $obj;
            }
            $i++;
        }
    }
}



/*
 * Affichage page
 */


$deleteImgSrc = DOL_URL_ROOT."/MCCImport/img/delete.png";
$updateImgSrc = DOL_URL_ROOT."/MCCImport/img/update.png";

$html=new Form($db);

?>

<script type="text/javascript">
    function agregarCategoria(){
        var frm = window.document.getElementById('frm');
        var txtAction = window.document.getElementById('action');
        var txtCategoria = window.document.getElementById('newCategoryName');

        if (txtCategoria.value == ""){
            alert ("Debe ingresar un nombre para la categoria");
            txtCategoria.focus();
            return;
        }

        txtAction.value = "addCategory";

        frm.submit();

    }

    function modificarCategoria(id){

        var frm = window.document.getElementById('frm');
        var txtAction = window.document.getElementById('action');
        var txtCategoriaId = window.document.getElementById('currentCategoryId');
        var txtCategoria = window.document.getElementById('currentCategoryName');
        var txtAccount = window.document.getElementById('currentAccount');
        var txtCategoriaMod = window.document.getElementById('categoryName'+id);
        var cboAccountMod = window.document.getElementById('account'+id);

        if (txtCategoriaMod.value == ""){
            alert ("Debe ingresar un nombre para la categoria");
            txtCategoriaMod.focus();
            return;
        }

        if (confirm("Esta seguro que desea modificar la categoria seleccionada?")){
            txtCategoriaId.value = id;
            txtCategoria.value = txtCategoriaMod.value;
            txtAction.value = "modifyCategory";
            txtAccount.value = cboAccountMod.value;

            frm.submit();
        }


    }

    function eliminarCategoria(id){
        var frm = window.document.getElementById('frm');
        var txtAction = window.document.getElementById('action');
        var txtCategoriaId = window.document.getElementById('currentCategoryId');

        if (confirm("Esta seguro que desea eliminar la categoria seleccionada?")){
            txtCategoriaId.value = id;
            txtAction.value = "deleteCategory";

            frm.submit();
        }
    }
</script>

<?php

print '<table class="noborder" width="100%">';

// Cas du parametre TAX_MODE
print '<form action="'.$_SERVER["PHP_SELF"].'" method="post" id="frm">';
print '<input type="hidden" name="action" id="action" value=""/>';
print '<input type="hidden" name="currentCategoryId" id="currentCategoryId" value=""/>';
print '<input type="hidden" name="currentCategoryName" id="currentCategoryName" value=""/>';
print '<input type="hidden" name="currentAccount" id="currentAccount" value=""/>';
print '<tr class="liste_titre">';
print '<td>Configuraci&oacute;n</td>';
print '<tr><td>&nbsp;</td></tr>';
print "</tr>\n";
print '<tr '.$bc[false].'><td width="200">';
?>
<table cellpadding="0" cellspacing="0" width="100%">
    <tr class="liste_titre">
        <td >
            Categor&iacute;as
        </td>
    </tr>
    <?php
    foreach ($categories as $c) {
        ?>
    <tr>
        <td>
            <input type="hidden" name="idCategory" value="<?php echo($c->id);?>"/>
            <input type="text" name="categoryName<?php echo($c->id);?>" id="categoryName<?php echo($c->id);?>" value="<?php echo($c->name);?>"/>
            <select name="account" id="account<?php echo($c->id);?>" class="flat">
                <?php
                foreach ($accounts as $a) {
                    ?>
                <option value="<?php print($a->rowid); ?>" <?php if($a->rowid == $c->accountId){print('selected');} ?> ><?php print($a->label); ?></option>
                    <?php
                }
                ?>

            </select>
            <img align="middle" src="<?php echo $updateImgSrc;?>" border="0" onclick="modificarCategoria('<?php echo($c->id);?>');" style="cursor:pointer;">
            <img align="middle" src="<?php echo $deleteImgSrc;?>" border="0" onclick="eliminarCategoria('<?php echo($c->id);?>');"  style="cursor:pointer;">
        </td>
    </tr>
    <?php
}
?>
    <tr>
        <td>
            Agregar nueva Categor&iacute;a
        </td>
    </tr>
    <tr>
        <td>
            <input type="text" name="newCategoryName" id="newCategoryName" value=""/>
            <select name="account" id="account" class="flat">
                <?php
                foreach ($accounts as $a) {
                    ?>
                <option value="<?php print($a->rowid); ?>"><?php print($a->label); ?></option>
                    <?php
                }
                ?>

            </select>
            &nbsp;&nbsp;<input type="button" value="Agregar" onclick="agregarCategoria();">
        </td>
    </tr>
</table>
</td></tr>
<?php if (count($categories) > 0) { ?>
<tr><td>&nbsp;</td></tr>
<tr><td>
        <table cellpadding="0" cellspacing="0" width="100%">
            <tr class="liste_titre">
                <td >
                    Reglas
                </td>
            </tr>
            <tr>
                <td>
                    <iframe style="border:none;" src="<?php echo DOL_URL_ROOT.'/MCCImport/adminRules.php?selectedCategory='.$categories[0]->id;?>" width="100%" height="400px" ></iframe>
                </td>
            </tr>
        </table>
</td></tr>
<?php } ?>
<?php

print '</form>';

print "</table>\n";

$db->close();

llxFooter('$Date: 2008/11/04 17:26:33 $ - $Revision: 1.2 $');
?>
